﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
	import com.actionscriptfacile.ui.text.UITextField;
	import flash.events.TimerEvent;
	import flash.utils.Timer;
	import com.as3facile.DefaultButton;

	import flash.events.MouseEvent;
	
	import com.demonsters.debugger.MonsterDebugger;
	
	import flash.events.Event;
	import flash.display.Sprite;
	
	
	
	// definit la couleur de fond du swf
	[SWF(backgroundColor="0xffffff")] 

	public class Main extends Sprite
	{
		private var oCompteur : Timer;
		
		// horloge analogique		
		private var oHorloge : Horloge;
		private var oHorlogeMini : Horloge;
		
		
		// horloge digital
		private var oDigital : UITextField;	
		

		/**
		 * Constructeur.
		 * 
		 * Compiler avec le SDK Flex 4.6
		 * 
		 * -swf-version = 18 : pour l'API Flash Player 11.5
		 * -default-frame-rate 40 : nombre d'images par secondes
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * 
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);
			
			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start horloge");
			
			this.buildUI();
		}


		/**
		 * Construit l'affichage de l'application.
		 * 
		 * 
		 */
		private function buildUI() : void
		{ 	
			oHorloge = new Horloge();
			this.addChild(oHorloge);
			
			// ajoute une 2ème horloge sur la scène
			oHorlogeMini = new Horloge();
			oHorlogeMini.x = 370;
			oHorlogeMini.y = 90;
			oHorlogeMini.scaleX = 0.5;// réduit sa taille
			oHorlogeMini.scaleY = 0.5;
			this.addChild(oHorlogeMini);
			
			// pour mettre les aiguilles à la bonne place
			var oDate : Date = new Date();// récupère l'heure sur le pc du visiteur
			this.initHeureAnalogique(oDate, oHorloge);// permet d'initialiser la position des aiguilles pour l'horloge de grande taille
			this.initHeureAnalogique(oDate, oHorlogeMini);// permet d'initialiser la position des aiguilles pour l'horloge de taille réduite


			// construit une horloge digitale
			oDigital = this.addText("00");
			oDigital.x = oHorlogeMini.x;
			oDigital.y = oHorlogeMini.y + oHorlogeMini.height + 30;
			this.addChild(oDigital);
			initHeureDigitale(oDate, oDigital);// permet d'initialiser l'horloge digitale


			// Timer envoie un évènement toutes les x secondes
			oCompteur = new Timer(1000);// nombre de secondes - nombre d'appel (infini si non renseigné)
			oCompteur.addEventListener(TimerEvent.TIMER, onUpdateTime);// envoie un évènement toutes les x secondes
			// TimerEvent.TIMER_COMPLETE lorsqu'il y a un nombre d'appel défini, envoie un évènement après le dernier appel
						
									
			// Création du bouton pour le menu contextuel
			var oBtnStartGame:DefaultButton = new DefaultButton();
			oBtnStartGame.getObject().label = "Start / Stop";
			oBtnStartGame.getObject().x = stage.stageWidth - oBtnStartGame.width - 40;
			oBtnStartGame.getObject().y = 33;
			oBtnStartGame.getObject().addEventListener ( MouseEvent.CLICK, onStartDigitalTimer );
			this.addChild(oBtnStartGame);
		}


		/**
		 * Mets à jour l'heure dès l'appui sur le bouton.
		 * 
		 */
		private function onStartDigitalTimer(event : MouseEvent) : void
		{
			// si le compteur n'est pas activé, lance le démarrage
			if( !oCompteur.running )
			{
				MonsterDebugger.trace(this, "Compteur démarré");
				this.onUpdateTime(null);// pour démarrer de suite les horloges
				oCompteur.start();// démarre le Timer et les horloges
			}
			else
			{
				MonsterDebugger.trace(this, "Compteur arrêté");
				oCompteur.stop();// démarre le Timer et les horloges
			}
		}


	
		/**
		 * Appelé toutes les secondes par Timer.
		 * 
		 */
		private function onUpdateTime(event : TimerEvent) : void 
		{
			// pour mettre les horloges à jour
			var oDate : Date = new Date();// récupère l'heure sur le pc du visiteur
			this.initHeureAnalogique(oDate, oHorloge);// permet d'initialiser la position des aiguilles pour l'horloge de grande taille
			this.initHeureAnalogique(oDate, oHorlogeMini);// permet d'initialiser la position des aiguilles pour l'horloge de taille réduite
			this.initHeureDigitale(oDate, oDigital);// permet d'initialiser l'horloge digitale
		}
		
		
		

		/**
		 * Mets à jour l'horloge digitale.
		 * 
		 * @param oDate : objet date pour récupérer l'heure courante sur le pc du visiteur
		 * @param oDisplay : le champ texte à mettre à jour
		 * 
		 */
		private function initHeureDigitale(oDate : Date, oDigital : UITextField) : void
		{
			var iSecondes:uint = oDate.getSeconds();
			var iMinutes:uint = oDate.getMinutes();
			var iHeures:uint = oDate.getHours();
			
			// ajout un 0 si le nombre est inférieur à 10
			var sSecondes:String;
			var sMinutes:String;
			var sHeures:String;
			
			if(iSecondes < 10)
				sSecondes = "0"+iSecondes.toString();
			else
				sSecondes = iSecondes.toString();	
			
			if(iMinutes < 10)
				sMinutes = "0"+iMinutes.toString();
			else
				sMinutes = iMinutes.toString();		
			
			if(iHeures < 10)
				sHeures = "0"+iHeures.toString();
			else
				sHeures = iHeures.toString();			
					
			oDigital.text = sHeures + " : "+sMinutes+" : "+sSecondes;// mets à jour le texte de l'horloge digital
		}


		/**
		 * Mets à jour la position des aiguilles d'une horloge.
		 * 
		 * @param oDate : objet date pour récupérer l'heure courante sur le pc du visiteur
		 * @param oDisplay : le clip horloge à mettre à jour
		 * 
		 */
		private function initHeureAnalogique(oDate:Date, oDisplay:Horloge) : void
		{
			var iSecondes:uint = oDate.getSeconds();
			var iMinutes:uint = oDate.getMinutes();
			var iHeures:uint = oDate.getHours();
		
			oDisplay.secondes.rotation = 180 + (iSecondes * 6);
			oDisplay.minutes.rotation = 180 + (iMinutes * 6);
			oDisplay.heures.rotation = 180 + (iHeures * 30) + (iMinutes * 0.5);
		}
		
		
		/**
		 * Création d'un champ texte.
		 * 
		 */
		private function addText(sValue:String) : UITextField
		{
			var oTxtField:UITextField = new UITextField();
			oTxtField.text = sValue;
			oTxtField.selectable = false;
			oTxtField.autoSizeLeft();
			oTxtField.alignLeft(); // centre le texte
			oTxtField.changeFormat("bold", true);
			oTxtField.changeFormat("size", 31);// changement de la taille de la police du texte
			oTxtField.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtField.changeFormat("color", 0x006f77);// changement de la couleur
			
			return oTxtField;	 
		}		


	}
}
